ng = 4;
a = 1;
sf = .27;
fs = 4000;
fc = 2000;
N = 256;
%%%%%
R = 2; % Overcomplete Ratio
M = R*N;
P = 5;
D = zeros(N,M);
Dp = zeros(P,M); % Dictionary parameter [a ct cf (n c)]
b = .7;
c = 0;
phi = 0;
%%%%% Testting parameters
p = 1;
EarQ = 9.26449;
minBW = 24.7;
%%%%%%%%%%%%%%%%%%%%%%%%%
dt = 1/fs;
t = dt:dt:N*dt;
ind = 1;
cf = 100;
nch = 0;
while (cf<=fc)
    nch = nch + 1;
    B = ((cf/EarQ)^p +(minBW)^p)^(1/p);
    gc = a*t.^(ng-1).*exp(-2*pi*b*B*t).*cos(2*pi*cf*t+c*log(t)+phi);
    gce = a*t.^(ng-1).*exp(-2*pi*b*B*t);
    [maxx,rt] = max(gce); 
    alpha = sqrt(sum(gc*gc'));
    ngc =  gc/alpha;
    start = 1;
    while (start <= N)
        D(1:start-1,ind) = ngc(N-start+2:N);
        D(start:N,ind) = ngc(1:N-start+1);        
        Dp(:,ind) = [alpha,start/fs,cf,ng,b];
        ind = ind+1; 
        if ind > M
            break
        end
        start = start + fix(rt);
    end
    cf = cf + sf*B;
    if ind > M
        display('full overcomplete');
        break
    end
end
ind = ind - 1
save(['gammaChirp',num2str(N),'v2.mat'],'D','Dp','N','fs')
% [U,S,V] = svd(D);
% sig = sum(S);
% plot(sig(1:N))
